3 # Copyright (C) 2009 Red Hat, Inc.
4 # Copyright (c) 2000-2006 Silicon Graphics, Inc. All Rights Reserved.
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; either version 2 of the License, or
9 # (at your option) any later version.
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 # GNU General Public License for more details.
16 # You should have received a copy of the GNU General Public License
17 # along with this program. If not, see <http://www.gnu.org/licenses/>.
21 for sed in sed gsed
; do
22 ($sed --version |
grep 'GNU sed') > /dev
/null
2>&1
23 if [ "$?" -eq 0 ]; then
28 if [ -z "$SED" ]; then
29 echo "$0: GNU sed not found"
35 if [ "$HOSTOS" == "Linux" ]
37 command dd --help |
grep noxfer
> /dev
/null
2>&1
41 command dd status
=noxfer $@
50 # poke_file 'test.img' 512 '\xff\xfe'
53 printf "$3" |
dd "of=$1" bs
=1 "seek=$2" conv
=notrunc
&>/dev
/null
56 # poke_file_le $img_filename $offset $byte_width $value
57 # Example: poke_file_le "$TEST_IMG" 512 2 65534
60 local img
=$1 ofs
=$2 len
=$3 val
=$4 str
=''
63 str
+=$
(printf '\\x%02x' $
((val
& 0xff)))
67 poke_file
"$img" "$ofs" "$str"
70 # poke_file_be $img_filename $offset $byte_width $value
71 # Example: poke_file_be "$TEST_IMG" 512 2 65279
74 local img
=$1 ofs
=$2 len
=$3 val
=$4
75 local str
=$
(printf "%0$((len * 2))x\n" $val |
sed 's/\(..\)/\\x\1/g')
77 poke_file
"$img" "$ofs" "$str"
80 # peek_file_le 'test.img' 512 2 => 65534
83 local val
=0 shift=0 byte
85 # coreutils' od --endian is not portable, so manually assemble bytes.
86 for byte
in $
(od -j"$2" -N"$3" -An -v -tu1 "$1"); do
87 val
=$
(( val |
(byte
<< shift) ))
93 # peek_file_be 'test.img' 512 2 => 65279
98 # coreutils' od --endian is not portable, so manually assemble bytes.
99 for byte
in $
(od -j"$2" -N"$3" -An -v -tu1 "$1"); do
100 val
=$
(( (val
<< 8) | byte ))
105 # peek_file_raw 'test.img' 512 2 => '\xff\xfe'. Do not use if the raw data
106 # is likely to contain \0 or trailing \n.
109 dd if="$1" bs=1 skip="$2" count="$3" status=none
113 test -f $config || config=../common.config
116 echo "$0: failed to find common.config"
121 echo "$0: failed to source common.config"
125 # Set the variables to the empty string to turn Valgrind off
126 # for specific processes, e.g.
127 # $ VALGRIND_QEMU_IO= ./check -qcow2 -valgrind 015
129 : ${VALGRIND_QEMU_VM=$VALGRIND_QEMU}
130 : ${VALGRIND_QEMU_IMG=$VALGRIND_QEMU}
131 : ${VALGRIND_QEMU_IO=$VALGRIND_QEMU}
132 : ${VALGRIND_QEMU_NBD=$VALGRIND_QEMU}
133 : ${VALGRIND_QSD=$VALGRIND_QEMU}
135 # The Valgrind own parameters may be set with
136 # its environment variable VALGRIND_OPTS, e.g.
137 # $ VALGRIND_OPTS="--leak-check=yes" ./check -qcow2 -valgrind 015
141 local VALGRIND_LOGFILE="$1"
143 if [[ "${VALGRIND_QEMU}" == "y" && "${NO_VALGRIND}" != "y" ]]; then
144 exec valgrind --log-file="${VALGRIND_LOGFILE}" --error-exitcode=99 "$@"
150 _qemu_proc_valgrind_log()
152 local VALGRIND_LOGFILE="$1"
154 if [[ "${VALGRIND_QEMU}" == "y" && "${NO_VALGRIND}" != "y" ]]; then
155 if [ $RETVAL == 99 ]; then
156 cat "${VALGRIND_LOGFILE}"
158 rm -f "${VALGRIND_LOGFILE}"
164 local VALGRIND_LOGFILE="${TEST_DIR}"/$$.valgrind
166 if [ -n "${QEMU_NEED_PID}" ]; then
167 echo $BASHPID > "${QEMU_TEST_DIR}/qemu-${_QEMU_HANDLE}.pid"
169 VALGRIND_QEMU="${VALGRIND_QEMU_VM}" _qemu_proc_exec "${VALGRIND_LOGFILE}" \
170 "$QEMU_PROG" $QEMU_OPTIONS "$@"
173 _qemu_proc_valgrind_log "${VALGRIND_LOGFILE}" $RETVAL
179 local VALGRIND_LOGFILE="${TEST_DIR}"/$$.valgrind
181 VALGRIND_QEMU="${VALGRIND_QEMU_IMG}" _qemu_proc_exec "${VALGRIND_LOGFILE}" \
182 "$QEMU_IMG_PROG" $QEMU_IMG_OPTIONS "$@"
185 _qemu_proc_valgrind_log "${VALGRIND_LOGFILE}" $RETVAL
191 local VALGRIND_LOGFILE="${TEST_DIR}"/$$.valgrind
192 local QEMU_IO_ARGS="$QEMU_IO_OPTIONS"
193 if [ "$IMGOPTSSYNTAX" = "true" ]; then
194 QEMU_IO_ARGS="--image-opts $QEMU_IO_ARGS"
195 if [ -n "$IMGKEYSECRET" ]; then
196 QEMU_IO_ARGS="--object secret,id=keysec0,data=$IMGKEYSECRET $QEMU_IO_ARGS"
200 VALGRIND_QEMU="${VALGRIND_QEMU_IO}" _qemu_proc_exec "${VALGRIND_LOGFILE}" \
201 "$QEMU_IO_PROG" $QEMU_IO_ARGS "$@"
204 _qemu_proc_valgrind_log "${VALGRIND_LOGFILE}" $RETVAL
210 local VALGRIND_LOGFILE="${TEST_DIR}"/$$.valgrind
212 VALGRIND_QEMU="${VALGRIND_QEMU_NBD}" _qemu_proc_exec "${VALGRIND_LOGFILE}" \
213 "$QEMU_NBD_PROG" --pid-file="${QEMU_TEST_DIR}/qemu-nbd.pid" \
214 $QEMU_NBD_OPTIONS "$@"
217 _qemu_proc_valgrind_log "${VALGRIND_LOGFILE}" $RETVAL
221 _qemu_storage_daemon_wrapper()
223 local VALGRIND_LOGFILE="${TEST_DIR}"/$$.valgrind
225 if [ -n "${QSD_NEED_PID}" ]; then
226 echo $BASHPID > "${QEMU_TEST_DIR}/qemu-storage-daemon.pid"
228 VALGRIND_QEMU="${VALGRIND_QSD}" _qemu_proc_exec "${VALGRIND_LOGFILE}" \
229 "$QSD_PROG" $QSD_OPTIONS "$@"
232 _qemu_proc_valgrind_log "${VALGRIND_LOGFILE}" $RETVAL
236 # Valgrind bug #409141 https://bugs.kde.org/show_bug.cgi?id=409141
237 # Until valgrind 3.16+ is ubiquitous, we must work around a hang in
238 # valgrind when issuing sigkill. Disable valgrind for this invocation.
244 export QEMU=_qemu_wrapper
245 export QEMU_IMG=_qemu_img_wrapper
246 export QEMU_IO=_qemu_io_wrapper
247 export QEMU_NBD=_qemu_nbd_wrapper
248 export QSD=_qemu_storage_daemon_wrapper
250 if [ "$IMGOPTSSYNTAX" = "true" ]; then
251 DRIVER="driver=$IMGFMT"
252 QEMU_IMG_EXTRA_ARGS="--image-opts $QEMU_IMG_EXTRA_ARGS"
253 if [ -n "$IMGKEYSECRET" ]; then
254 QEMU_IMG_EXTRA_ARGS="--object secret,id=keysec0,data=$IMGKEYSECRET $QEMU_IMG_EXTRA_ARGS"
256 if [ "$IMGFMT" = "luks" ]; then
257 DRIVER="$DRIVER,key-secret=keysec0"
259 if [ "$IMGPROTO" = "file" ]; then
260 TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
261 TEST_IMG="$DRIVER,file.filename=$TEST_DIR/t.$IMGFMT"
262 elif [ "$IMGPROTO" = "nbd" ]; then
263 TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
264 TEST_IMG="$DRIVER,file.driver=nbd,file.type=unix"
265 TEST_IMG="$TEST_IMG,file.path=$SOCK_DIR/nbd"
266 elif [ "$IMGPROTO" = "fuse" ]; then
267 TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
268 TEST_IMG="$DRIVER,file.filename=$SOCK_DIR/fuse-t.$IMGFMT"
269 elif [ "$IMGPROTO" = "ssh" ]; then
270 TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
271 TEST_IMG="$DRIVER,file.driver=ssh,file.host=127.0.0.1,file.path=$TEST_IMG_FILE"
272 elif [ "$IMGPROTO" = "nfs" ]; then
273 TEST_DIR="$DRIVER,file.driver=nfs,file.filename=nfs://127.0.0.1/$TEST_DIR"
274 TEST_IMG=$TEST_DIR/t.$IMGFMT
276 TEST_IMG="$DRIVER,file.driver=$IMGPROTO,file.filename=$TEST_DIR/t.$IMGFMT"
280 if [ "$IMGPROTO" = "file" ]; then
281 TEST_IMG=$TEST_DIR/t.$IMGFMT
282 elif [ "$IMGPROTO" = "nbd" ]; then
283 TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
284 TEST_IMG="nbd+unix:///?socket=$SOCK_DIR/nbd"
285 elif [ "$IMGPROTO" = "fuse" ]; then
286 TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
287 TEST_IMG="$SOCK_DIR/fuse-t.$IMGFMT"
288 elif [ "$IMGPROTO" = "ssh" ]; then
289 TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
290 REMOTE_TEST_DIR="ssh://\\($USER@\\)\\?127.0.0.1\\(:[0-9]\\+\\)\\?$TEST_DIR"
291 TEST_IMG="ssh://127.0.0.1$TEST_IMG_FILE"
292 elif [ "$IMGPROTO" = "nfs" ]; then
293 TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
294 REMOTE_TEST_DIR="nfs://127.0.0.1$TEST_DIR"
295 TEST_IMG="nfs://127.0.0.1$TEST_IMG_FILE"
297 TEST_IMG=$IMGPROTO:$TEST_DIR/t.$IMGFMT
300 ORIG_TEST_IMG_FILE=$TEST_IMG_FILE
301 ORIG_TEST_IMG="$TEST_IMG"
306 if [ -z "$TEST_DIR" ]; then
307 TEST_DIR=$PWD/scratch
310 QEMU_TEST_DIR="${TEST_DIR}"
312 if [ ! -e "$TEST_DIR" ]; then
316 if [ ! -d "$TEST_DIR" ]; then
317 echo "common.rc: Error: \$TEST_DIR ($TEST_DIR) is not a directory"
321 if [ -z "$REMOTE_TEST_DIR" ]; then
322 REMOTE_TEST_DIR="$TEST_DIR"
325 if [ ! -d "$SAMPLE_IMG_DIR" ]; then
326 echo "common.rc: Error: \$SAMPLE_IMG_DIR ($SAMPLE_IMG_DIR) is not a directory"
332 SAMPLE_IMG_FILE="${1%\.bz2}"
333 TEST_IMG="$TEST_DIR/$SAMPLE_IMG_FILE"
334 bzcat "$SAMPLE_IMG_DIR/$1" > "$TEST_IMG"
337 echo "_use_sample_img error, cannot extract '$SAMPLE_IMG_DIR/$1'"
344 if [ -f "${QEMU_TEST_DIR}/qemu-nbd.pid" ]; then
346 read QEMU_NBD_PID < "${QEMU_TEST_DIR}/qemu-nbd.pid"
348 rm -f "${QEMU_TEST_DIR}/qemu-nbd.pid" "$SOCK_DIR/nbd"
352 # Gets the data_file value from IMGOPTS and replaces the '$TEST_IMG'
354 # Caution: The replacement is done with sed, so $1 must be escaped
355 # properly. (The delimiter is '#'.)
358 if ! echo "$IMGOPTS" | grep -q 'data_file='; then
362 echo "$IMGOPTS" | sed -e 's/.*data_file=\([^,]*\).*/\1/' \
363 | sed -e "s#\\\$TEST_IMG#$1#"
366 # Translate a $TEST_IMG to its corresponding $TEST_IMG_FILE for
367 # different protocols
368 _test_img_to_test_img_file()
376 echo "$1" | sed -e "s#$SOCK_DIR/fuse-#$TEST_DIR/#"
380 echo "$1" | sed -e "s#nfs://127.0.0.1##"
385 sed -e "s#ssh://\\($USER@\\)\\?127.0.0.1\\(:[0-9]\\+\\)\\?##"
396 # extra qemu-img options can be added by tests
397 # at least one argument (the image size) needs to be added
398 local extra_img_options=""
402 local backing_file=""
403 local object_options=""
404 local opts_param=false
407 if [[ $IMGPROTO == fuse && $TEST_IMG == $SOCK_DIR/fuse-* ]]; then
408 # The caller may be trying to overwrite an existing image
409 _rm_test_img "$TEST_IMG"
412 if [ -z "$TEST_IMG_FILE" ]; then
414 elif [ "$IMGOPTSSYNTAX" != "true" -a \
415 "$TEST_IMG_FILE" = "$ORIG_TEST_IMG_FILE" ]; then
416 # Handle cases of tests only updating TEST_IMG, but not TEST_IMG_FILE
417 img_name=$(_test_img_to_test_img_file "$TEST_IMG")
418 if [ "$?" != 0 ]; then
419 img_name=$TEST_IMG_FILE
422 # $TEST_IMG_FILE is not the default value, so it definitely has been
423 # modified by the test
424 img_name=$TEST_IMG_FILE
427 if [ -n "$IMGOPTS" ]; then
428 imgopts_expanded=$(echo "$IMGOPTS" | sed -e "s#\\\$TEST_IMG#$img_name#")
429 optstr=$(_optstr_add "$optstr" "$imgopts_expanded")
431 if [ -n "$IMGKEYSECRET" ]; then
432 object_options="--object secret,id=keysec0,data=$IMGKEYSECRET"
433 optstr=$(_optstr_add "$optstr" "key-secret=keysec0")
437 if [ "$use_backing" = "1" -a -z "$backing_file" ]; then
440 elif $opts_param; then
441 optstr=$(_optstr_add "$optstr" "$param")
460 misc_params=("${misc_params[@]}" "$param")
465 if [ \( "$IMGFMT" = "qcow2" -o "$IMGFMT" = "qed" \) -a -n "$CLUSTER_SIZE" ]; then
466 optstr=$(_optstr_add "$optstr" "cluster_size=$CLUSTER_SIZE")
469 if [ -n "$optstr" ]; then
470 extra_img_options="-o $optstr $extra_img_options"
473 if [ $IMGPROTO = "nbd" ]; then
477 # XXX(hch): have global image options?
479 if [ $use_backing = 1 ]; then
480 $QEMU_IMG create $object_options -f $IMGFMT $extra_img_options -b "$backing_file" "$img_name" "${misc_params[@]}" 2>&1
482 $QEMU_IMG create $object_options -f $IMGFMT $extra_img_options "$img_name" "${misc_params[@]}" 2>&1
484 ) | _filter_img_create
486 # Start an NBD server on the image file, which is what we'll be talking to.
487 # Once NBD gains resize support, we may also want to use -f raw at the
488 # server and interpret format over NBD, but for now, the format is
489 # interpreted at the server and raw data sent over NBD.
490 if [ $IMGPROTO = "nbd" ]; then
491 # Pass a sufficiently high number to -e that should be enough for all
493 eval "$QEMU_NBD -v -t -k '$SOCK_DIR/nbd' -f $IMGFMT -e 42 -x '' $TEST_IMG_FILE >/dev/null &"
494 sleep 1 # FIXME: qemu-nbd needs to be listening before we continue
497 if [ $IMGPROTO = "fuse" -a -f "$img_name" ]; then
503 export_mp=$(echo "$img_name" | sed -e "s#$TEST_DIR/#$SOCK_DIR/fuse-#")
504 if ! echo "$export_mp" | grep -q "^$SOCK_DIR"; then
505 echo 'Cannot use FUSE exports with images outside of TEST_DIR' >&2
510 rm -f "$SOCK_DIR/fuse-output"
512 # Usually, users would export formatted nodes. But we present fuse as a
513 # protocol-level driver here, so we have to leave the format to the
515 QSD_NEED_PID=y $QSD \
516 --blockdev file,node-name=export-node,filename=$img_name,discard=unmap \
517 --export fuse,id=fuse-export,node-name=export-node,mountpoint="$export_mp",writable=on,growable=on \
520 pidfile="$QEMU_TEST_DIR/qemu-storage-daemon.pid"
522 # Wait for the PID file
523 while [ ! -f "$pidfile" ]; do
527 pid=$(cat "$pidfile")
531 FUSE_EXPORTS+=("$export_mp")
539 if [[ $IMGPROTO == fuse && $img == $SOCK_DIR/fuse-* ]]; then
547 for i in "${!FUSE_EXPORTS[@]}"; do
548 if [ "${FUSE_EXPORTS[i]}" = "$img" ]; then
554 if [ -z "$index" ]; then
555 # Probably gone already
559 kill "${FUSE_PIDS[index]}"
561 # Wait until the mount is gone
564 # Will show the mount point; if the mount is still there,
566 df_output=$(df "$img" 2>/dev/null)
568 # But df may also show an error ("Transpoint endpoint not
569 # connected"), so retry in such cases
570 if [ -n "$df_output" ]; then
571 if ! echo "$df_output" | grep -q "$img"; then
578 timeout=$((timeout - 1))
579 if [ "$timeout" = 0 ]; then
580 echo 'Failed to take down FUSE export' >&2
587 unset "FUSE_PIDS[$index]"
588 unset "FUSE_EXPORTS[$index]"
590 image_file=$(echo "$img" | sed -e "s#$SOCK_DIR/fuse-#$TEST_DIR/#")
591 _rm_test_img "$image_file"
595 if [ "$IMGFMT" = "vmdk" ]; then
596 # Remove all the extents for vmdk
597 "$QEMU_IMG" info "$img" 2>/dev/null | grep 'filename:' | cut -f 2 -d: \
598 | xargs -I {} rm -f "{}"
599 elif [ "$IMGFMT" = "qcow2" ]; then
600 # Remove external data file
601 if data_file=$(_get_data_file "$img"); then
614 rm -f "$TEST_IMG_FILE"
620 for mp in "${FUSE_EXPORTS[@]}"; do
629 _rm_test_img "$TEST_DIR/t.$IMGFMT"
630 _rm_test_img "$TEST_DIR/t.$IMGFMT.orig"
631 _rm_test_img "$TEST_DIR/t.$IMGFMT.base"
632 if [ -n "$SAMPLE_IMG_FILE" ]
634 rm -f "$TEST_DIR/$SAMPLE_IMG_FILE"
636 TEST_IMG="$ORIG_TEST_IMG"
641 rbd --no-progress rm "$TEST_DIR/t.$IMGFMT" > /dev/null
650 if [ "$IMGOPTSSYNTAX" = "true" ]; then
651 $QEMU_IMG check $QEMU_IMG_EXTRA_ARGS "$@" "$TEST_IMG" 2>&1
653 $QEMU_IMG check "$@" -f $IMGFMT "$TEST_IMG" 2>&1
655 ) | _filter_testdir | _filter_qemu_img_check
657 # return real qemu_img check status, to analyze in
658 # _check_test_img_ignore_leaks
659 return ${PIPESTATUS[0]}
662 _check_test_img_ignore_leaks()
664 out=$(_check_test_img "$@")
666 if [ $status = 3 ]; then
667 # This must correspond to success output in dump_human_image_check()
668 echo "No errors were found on the image."
677 if [[ "$1" == "--format-specific" ]]; then
678 local format_specific=1
681 local format_specific=0
685 regex_json_spec_start='^ *"format-specific": \{'
686 $QEMU_IMG info $QEMU_IMG_EXTRA_ARGS "$@" "$TEST_IMG" 2>&1 | \
687 sed -e "s#$REMOTE_TEST_DIR#TEST_DIR#g" \
688 -e "s#$IMGPROTO:$TEST_DIR#TEST_DIR#g" \
689 -e "s#$TEST_DIR#TEST_DIR#g" \
690 -e "s#$SOCK_DIR/fuse-#TEST_DIR/#g" \
691 -e "s#$IMGFMT#IMGFMT#g" \
692 -e "/^disk size:/ D" \
693 -e "/actual-size/ D" | \
694 while IFS='' read -r line; do
695 if [[ $format_specific == 1 ]]; then
697 elif [[ $line == "Format specific information:" ]]; then
699 elif [[ $line =~ $regex_json_spec_start ]]; then
701 regex_json_spec_end="^${line%%[^ ]*}\\},? *$"
703 if [[ $discard == 0 ]]; then
705 elif [[ $discard == 1 && ! $line ]]; then
708 elif [[ $discard == 2 && $line =~ $regex_json_spec_end ]]; then
714 # bail out, setting up .notrun file
718 echo "$*" >"$OUTPUT_DIR/$seq.notrun"
719 echo "$seq not run: $*"
724 # bail out, setting up .casenotrun file
725 # The function _casenotrun() is used as a notifier. It is the
726 # caller's responsibility to make skipped a particular test.
730 echo " [case not run] $*" >>"$OUTPUT_DIR/$seq.casenotrun"
733 # just plain bail out
737 echo "$*" | tee -a "$OUTPUT_DIR/$seq.full"
738 echo "(see $seq.full for details)"
743 # tests whether $IMGFMT is one of the supported image formats for a test
747 # "generic" is suitable for most image formats. For some formats it doesn't
748 # work, however (most notably read-only formats), so they can opt out by
749 # setting IMGFMT_GENERIC to false.
751 if [ "$f" = "$IMGFMT" -o "$f" = "generic" -a "$IMGFMT_GENERIC" = "true" ]; then
752 if [ "$IMGFMT" = "luks" ]; then
753 _require_working_luks
759 _notrun "not suitable for this image format: $IMGFMT"
762 # tests whether $IMGFMT is one of the unsupported image format for a test
767 if [ "$f" = "$IMGFMT" ]; then
768 _notrun "not suitable for this image format: $IMGFMT"
773 # tests whether $IMGPROTO is one of the supported image protocols for a test
778 if [ "$f" = "$IMGPROTO" -o "$f" = "generic" ]; then
783 _notrun "not suitable for this image protocol: $IMGPROTO"
786 # tests whether $IMGPROTO is specified as an unsupported image protocol for a test
791 if [ "$f" = "$IMGPROTO" ]; then
792 _notrun "not suitable for this image protocol: $IMGPROTO"
798 # tests whether the host OS is one of the supported OSes for a test
804 if [ "$h" = "$HOSTOS" ]
810 _notrun "not suitable for this OS: $HOSTOS"
813 _supported_cache_modes()
816 if [ "$mode" = "$CACHEMODE" ]; then
820 _notrun "not suitable for cache mode: $CACHEMODE"
823 # Check whether the filesystem supports O_DIRECT
826 testfile="$TEST_DIR"/_check_o_direct
827 $QEMU_IMG create -f raw "$testfile" 1M > /dev/null
828 out=$($QEMU_IO -f raw -t none -c quit "$testfile" 2>&1)
831 [[ "$out" != *"O_DIRECT"* ]]
836 if ! _check_o_direct; then
837 _notrun "file system on $TEST_DIR does not support O_DIRECT"
843 if [ $CACHEMODE == "none" ] || [ $CACHEMODE == "directsync" ]; then
850 # $1 - cache mode to use by default
851 # $2 - (optional) cache mode to use by default if O_DIRECT is not supported
852 _default_cache_mode()
854 if $CACHEMODE_IS_DEFAULT; then
855 if [ -z "$2" ] || _check_o_direct; then
860 QEMU_IO="$QEMU_IO --cache $CACHEMODE"
865 _supported_aio_modes()
868 if [ "$mode" = "$AIOMODE" ]; then
872 _notrun "not suitable for aio mode: $AIOMODE"
877 QEMU_IO="$QEMU_IO --aio $1"
880 _unsupported_imgopts()
884 # Add a space so tests can match for whitespace that marks the
885 # end of an option (\b or \> are not portable)
886 if echo "$IMGOPTS " | grep -q 2>/dev/null "$bad_opt"
888 _notrun "not suitable for image option: $bad_opt"
893 # Caution: Overwrites $TEST_DIR/t.luks
894 _require_working_luks()
896 file="$TEST_DIR/t.luks"
899 $QEMU_IMG create -f luks \
900 --object secret,id=sec0,data=hunter0 \
909 IMGFMT='luks' _rm_test_img "$file"
911 if [ $status != 0 ]; then
912 reason=$(echo "$output" | grep "$file:" | $SED -e "s#.*$file: *##")
913 if [ -z "$reason" ]; then
914 reason="Failed to create a LUKS image"
920 # this test requires that a specified command (executable) exists
924 if [ "$1" = "QEMU" ]; then
926 elif [ "$1" = "QEMU_IMG" ]; then
928 elif [ "$1" = "QEMU_IO" ]; then
930 elif [ "$1" = "QEMU_NBD" ]; then
935 [ -x "$c" ] || _notrun "$1 utility required, skipped this test"
938 # Check that a set of drivers has been whitelisted in the QEMU binary
942 available=$($QEMU -drive format=help | \
943 sed -e '/Supported formats:/!d' -e 's/Supported formats://')
946 if ! echo "$available" | grep -q " $driver\( \|$\)"; then
947 _notrun "$driver not available"
952 # Check that we have a file system that allows huge (but very sparse) files
954 _require_large_file()
956 if ! truncate --size="$1" "$TEST_IMG"; then
957 _notrun "file system on $TEST_DIR does not support large enough files"
962 # Check that a set of devices is available in the QEMU binary
966 available=$($QEMU -M none -device help | \
967 grep ^name | sed -e 's/^name "//' -e 's/".*$//')
970 if ! echo "$available" | grep -q "$device" ; then
971 _notrun "$device not available"
976 _require_one_device_of()
978 available=$($QEMU -M none -device help | \
979 grep ^name | sed -e 's/^name "//' -e 's/".*$//')
982 if echo "$available" | grep -q "$device" ; then
986 _notrun "$* not available"
989 # make sure this script returns success